操作系统寒武纪 - 会让企业IT高兴吗?
594
2022-10-03
HDU 4336 Card Collector (容斥原理||概率DP)
Problem Description
In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award.As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
Input
The first line of each test case contains one integer N(1<=N<=20), indicating the number of different cards you need thecollect. The second line contains N numbers p1,p2,...,pN,(p1+p2+...+pN<=1), indicating the possibility of each card to appear in a bag of snacks. Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
Output
Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.You will get accepted if the difference between your answer and the standard answer is no more that 10−4.
Sample Input
10.120.1 0.4
Sample Output
10.00010.500
题意
在你的童年有过收集零食里面的卡片的经历吧!当你集得所有卡片的时候你会获得很多奖励。
输入的第一行代表需要集得卡片的数量N,接下来的一行有N个实数,代表每张卡片出现的概率,问最少需要买多少零食才可以集全所有卡片。
思路
容斥原理
假设第一张卡片出现概率为 P1 ,我们要获得它需要花费 1.0/P1 ,同理,其他卡片的花费也是如此 1.0/Pn ,但是我们在 P1 中花费时也有可能出现 P2 、 P3
于是很容易想到容斥原理,求得所有卡片花费集合的并便是答案。
概率dp
用 dp[i] 表示 i
假设总共有五张卡片,那么 i 最大为 25−1
比如:我们要计算 dp[(10101)2] ,它可以由 (00101)2 (10001)2 (10100)2 分别改变对应位状态得到,代表当前位的卡片我已经得到了,概率为 Pi
而当前要计算的状态我们认为一定会得到,因为这是必须的,默认置 dp[i]=1
每一个状态都是由比它小的其他状态通过改变一位二进制数转移得到的从 dp[0] 一直计算到 dp[2n−1]最后一个全 1 状态的值即获得所有卡片的期望数量。
容斥原理
#include 概率dp #include
版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。
发表评论
暂时没有评论,来抢沙发吧~